<?php

	/** Converts a base-10 number > 9 to a character over ASCII 65 = A, 
	 *  so 10 = A, 11 = B etc.
	 **/
	
	function c($n) {
		if($n > 9) $n = chr($n + 55);
		return $n;
	}
	
	
	/** Replaces the base-indicating digits with indices. **/
	
	function showbase($n) {
		$n = "$n";
		$n = str_replace("0", "₀", $n);
		$n = str_replace("1", "₁", $n);
		$n = str_replace("2", "₂", $n);
		$n = str_replace("3", "₃", $n);
		$n = str_replace("4", "₄", $n);
		$n = str_replace("5", "₅", $n);
		$n = str_replace("6", "₆", $n);
		$n = str_replace("7", "₇", $n);
		$n = str_replace("8", "₈", $n);
		$n = str_replace("9", "₉", $n);
		return $n;
	}
	
	
	/** The conversion function
	 *
	 * $z is a real number
	 * $b is the base to which we want to convert
	 * $k is the number of decimal places the converted number should have
	 * 
	 **/
	 
	function dec_alt($z, $b, $k, $showbase) {
		$i = floor($z);
		$q = $z - $i;
		
		// if no $k is set, use the precision of the input //
		if(!$k) $k = strlen(str_replace('0.', '', $q));
		
		// $b-base digits for integer part //
		while($i > 0) {
			$r = $i % $b;		// remainder
			$i = floor($i / $b);	// integer
			$s = c($r) . $s;
		}
		
		// $b-base digits for fractional part //
		if($q > 0) {
			$s .= ".";
			
			for($n = 0; $n <= $k; $n++) {
				$last_r = $r;
				$q = $q * $b;
				$r = floor($q);
				$q = $q - $r;
				
				// Checks last digit for rounding up or down //
				if($n == $k) {
					if($r >= $b / 2) {
						$s[strlen($s)-1] = c($last_r+1);
						break;
					}
				} else {
					// If there is nothing to round, add the digit to //
					// the string and convert it to ABC if necessary  //
					$s .= c($r);
				}
			}
		}

		// If first digit of $s is missing, add a 0 //
		$s = preg_replace('/^[.]/', "0.", $s);
		
		// Likewise, cut off trailing 0s in decimal places //
		$pat = '/([.].*)[0]+$/';
		while( preg_match($pat, $s) ) $s = preg_replace($pat, "$1", $s);
		
		// Shows an index with the base after the converted number //
		if($showbase) $s .= showbase($b);
				
		return $s;
	}
?>
